diff --git src/test/com/cloudera/sqoop/TestAllTables.java src/test/com/cloudera/sqoop/TestAllTables.java
index 4d5c33c..5eccb77 100644
--- src/test/com/cloudera/sqoop/TestAllTables.java
+++ src/test/com/cloudera/sqoop/TestAllTables.java
@@ -18,17 +18,17 @@
 
 package com.cloudera.sqoop;
 
-import java.io.BufferedReader;
-import java.io.File;
-import java.io.FileInputStream;
-import java.io.IOException;
-import java.io.InputStreamReader;
+import java.io.*;
 import java.sql.SQLException;
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
+import org.apache.hadoop.fs.FSDataInputStream;
+import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.io.IOUtils;
+import org.junit.After;
 import org.junit.Before;
 
 import com.cloudera.sqoop.testutil.CommonArgs;
@@ -122,9 +122,16 @@ public class TestAllTables extends ImportJobTestCase {
           + this.expectedStrings.get(0);
       this.expectedStrings.remove(0);
 
-      BufferedReader reader = new BufferedReader(
-          new InputStreamReader(new FileInputStream(
-          new File(filePath.toString()))));
+      BufferedReader reader = null;
+      if (!onPhysicalCluster) {
+        reader = new BufferedReader(
+            new InputStreamReader(new FileInputStream(
+                new File(filePath.toString()))));
+      } else {
+        FileSystem dfs = FileSystem.get(getConf());
+        FSDataInputStream dis = dfs.open(filePath);
+        reader = new BufferedReader(new InputStreamReader(dis));
+      }
       try {
         String line = reader.readLine();
         assertEquals("Table " + tableName + " expected a different string",
diff --git src/test/com/cloudera/sqoop/TestColumnTypes.java src/test/com/cloudera/sqoop/TestColumnTypes.java
index fa7f7ec..3794949 100644
--- src/test/com/cloudera/sqoop/TestColumnTypes.java
+++ src/test/com/cloudera/sqoop/TestColumnTypes.java
@@ -18,6 +18,7 @@
 
 package com.cloudera.sqoop;
 
+import com.cloudera.sqoop.testutil.CommonArgs;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 
diff --git src/test/com/cloudera/sqoop/TestMultiMaps.java src/test/com/cloudera/sqoop/TestMultiMaps.java
index 3c2da4b..0c822a2 100644
--- src/test/com/cloudera/sqoop/TestMultiMaps.java
+++ src/test/com/cloudera/sqoop/TestMultiMaps.java
@@ -22,6 +22,7 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.List;
 
+import com.cloudera.sqoop.testutil.*;
 import org.apache.commons.cli.ParseException;
 import org.apache.hadoop.conf.Configuration;
 import org.apache.hadoop.fs.FileStatus;
@@ -34,10 +35,6 @@ import org.apache.hadoop.util.ReflectionUtils;
 
 import com.cloudera.sqoop.SqoopOptions.InvalidOptionsException;
 import com.cloudera.sqoop.orm.CompilationManager;
-import com.cloudera.sqoop.testutil.CommonArgs;
-import com.cloudera.sqoop.testutil.HsqldbTestServer;
-import com.cloudera.sqoop.testutil.ImportJobTestCase;
-import com.cloudera.sqoop.testutil.SeqFileReader;
 import com.cloudera.sqoop.tool.ImportTool;
 import com.cloudera.sqoop.util.ClassLoaderStack;
 
@@ -89,7 +86,8 @@ public class TestMultiMaps extends ImportJobTestCase {
   protected List<Path> getDataFilePaths() throws IOException {
     List<Path> paths = new ArrayList<Path>();
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
 
     FileStatus [] stats = fs.listStatus(getTablePath(),
diff --git src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
index f6d2474..63e331e 100644
--- src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
+++ src/test/com/cloudera/sqoop/testutil/BaseSqoopTestCase.java
@@ -29,6 +29,7 @@ import java.util.Arrays;
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
 import org.apache.hadoop.conf.Configuration;
+import org.apache.hadoop.fs.FileSystem;
 import org.apache.hadoop.fs.Path;
 import org.apache.hadoop.util.StringUtils;
 import org.apache.log4j.BasicConfigurator;
@@ -50,6 +51,7 @@ public class BaseSqoopTestCase extends TestCase {
 
   public static final Log LOG = LogFactory.getLog(
       BaseSqoopTestCase.class.getName());
+  public static boolean onPhysicalCluster = false;
 
   /** Base directory for all temporary data. */
   public static final String TEMP_BASE_DIR;
@@ -166,7 +168,10 @@ public class BaseSqoopTestCase extends TestCase {
 
   @Before
   public void setUp() {
-
+    // The assumption is that correct HADOOP configuration will have it set to
+    // hdfs://namenode
+    onPhysicalCluster =
+        !CommonArgs.LOCAL_FS.equals(System.getProperty(CommonArgs.FS_DEFAULT_NAME));
     incrementTableNum();
 
     if (!isLog4jConfigured) {
@@ -218,6 +223,15 @@ public class BaseSqoopTestCase extends TestCase {
       LOG.error("Got SQLException: " + StringUtils.stringifyException(sqlE));
       fail("Got SQLException: " + StringUtils.stringifyException(sqlE));
     }
+    if (onPhysicalCluster) {
+      Path warehousePath = new Path(this.getWarehouseDir());
+      try {
+        FileSystem fs = FileSystem.get(getConf());
+        fs.delete(warehousePath);
+      } catch (IOException e) {
+        LOG.warn(e);
+      }
+    }
   }
 
   static final String BASE_COL_NAME = "DATA_COL";
diff --git src/test/com/cloudera/sqoop/testutil/CommonArgs.java src/test/com/cloudera/sqoop/testutil/CommonArgs.java
index aeeba66..36ef7b4 100644
--- src/test/com/cloudera/sqoop/testutil/CommonArgs.java
+++ src/test/com/cloudera/sqoop/testutil/CommonArgs.java
@@ -28,6 +28,16 @@ public final class CommonArgs {
   private CommonArgs() {
   }
 
+  public static String LOCAL_FS="file:///";
+  public static String FS_DEFAULT_NAME="fs.defaultfs.name"; // is deprecated past 0.21
+  public static String FS_DEFAULTFS="fs.defaultFS";
+
+  public static String getJobtrackerAddress () {
+    return System.getProperty("mapreduce.jobtracker.address", "local");
+  }
+  public static String getDefaultFS() {
+    return System.getProperty(FS_DEFAULT_NAME, LOCAL_FS);
+  }
   /**
    * Craft a list of arguments that are common to (virtually)
    * all Sqoop programs.
diff --git src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
index 5eaf828..1666abf 100644
--- src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
+++ src/test/com/cloudera/sqoop/testutil/ImportJobTestCase.java
@@ -148,8 +148,9 @@ public class ImportJobTestCase extends BaseSqoopTestCase {
 
       // Now open and check all part-files in the table path until we find
       // a non-empty one that we can verify contains the value.
-
-      FileSystem fs = FileSystem.getLocal(conf);
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
+      FileSystem fs = FileSystem.get(conf);
       FileStatus [] stats = fs.listStatus(tableDirPath);
 
       if (stats == null || stats.length == 0) {
diff --git src/test/com/cloudera/sqoop/testutil/SeqFileReader.java src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
index b30ac1b..28a544b 100644
--- src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
+++ src/test/com/cloudera/sqoop/testutil/SeqFileReader.java
@@ -29,6 +29,8 @@ import org.apache.hadoop.io.SequenceFile;
 import org.apache.hadoop.io.SequenceFile.Reader;
 import org.apache.hadoop.util.ReflectionUtils;
 
+import javax.print.attribute.standard.Copies;
+
 /**
  * Utility class to help with test cases. Just reads the first (k, v) pair
  * from a SequenceFile and returns the value part.
@@ -46,7 +48,8 @@ public final class SeqFileReader {
   public static Reader getSeqFileReader(String filename) throws IOException {
     // read from local filesystem
     Configuration conf = new Configuration();
-    conf.set("fs.default.name", "file:///");
+    if (!BaseSqoopTestCase.onPhysicalCluster)
+      conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
     FileSystem fs = FileSystem.get(conf);
     LOG.info("Opening SequenceFile " + filename);
     return new SequenceFile.Reader(fs, new Path(filename), conf);
@@ -57,7 +60,8 @@ public final class SeqFileReader {
     try {
       // read from local filesystem
       Configuration conf = new Configuration();
-      conf.set("fs.default.name", "file:///");
+      if (!BaseSqoopTestCase.onPhysicalCluster)
+        conf.set(CommonArgs.FS_DEFAULT_NAME, CommonArgs.LOCAL_FS);
       FileSystem fs = FileSystem.get(conf);
       r = new SequenceFile.Reader(fs, new Path(filename), conf);
       Object key = ReflectionUtils.newInstance(r.getKeyClass(), conf);