diff --git a/docs-1.2.0/index.html b/docs-1.2.0/index.html
index a4201d3..2ff2c57 100644
--- a/docs-1.2.0/index.html
+++ b/docs-1.2.0/index.html
@@ -2,6 +2,8 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Hue</title><link rel="stylesheet" href="docbook.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.75.2" /></head><body><div xml:lang="en" class="article" title="Hue" lang="en"><div class="titlepage"><div><div><h2 class="title"><a id="id429210"></a>Hue</h2></div></div><hr /></div><div class="section" title="1. Installation"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="_installation"></a>1. Installation</h2></div></div></div><p>The <a class="ulink" href="manual.html" target="_top">manual</a> has instructions to install Hue.</p></div><div class="section" title="2. SDK"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="_sdk"></a>2. SDK</h2></div></div></div><p>We encourage you to build an application within the Hue
 environment.  See the <a class="ulink" href="sdk/sdk.html" target="_top">SDK Documentation</a> to get started.</p></div><div class="section" title="3. Release Notes"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a id="_release_notes"></a>3. Release Notes</h2></div></div></div><p>Note that prior to version 0.9, Hue was "Cloudera Desktop".</p><div class="itemizedlist"><ul class="itemizedlist" type="disc"><li class="listitem">
+Feb 21, 2011 --- <a class="ulink" href="release-notes/release-notes-1.2.0.html" target="_top">Version 1.2.0</a>
+</li><li class="listitem">
 Oct 11, 2010 --- <a class="ulink" href="release-notes/release-notes-1.1.0.html" target="_top">Version 1.1.0</a>
 </li><li class="listitem">
 Aug 20, 2010 --- <a class="ulink" href="release-notes/release-notes-1.0.1.html" target="_top">Version 1.0.1</a>
diff --git a/index.html b/index.html
index 5258712..4b6d04e 100644
--- a/index.html
+++ b/index.html
@@ -42,12 +42,19 @@
       <span class="small">Hadoop User Experience</span></h1>
 
     <div class="description">
-      Hue is a browser-based desktop interface for interacting with Hadoop. It features a file browser, a job tracker, a Hive UI and more.
+      Hue is a browser-based desktop interface for interacting with Hadoop. It features a HDFS file browser, a job browser, a Hive UI and more.
     </div>
 
-    <h2>Hue 1.1.0</h2>
+    <h2>Hue 1.2.0</h2>
+    <p>Hue 1.2.0 is a minor release, largely focused on bug fixes and compatibility with <a href="https://docs.cloudera.com/display/DOC/CDH3+Quick+Start+Guide">Cloudera's Distribution for Apache Hadoop (CDH) version 3 beta 4</a>.</p>
+    <ul>
+      <li><a href="http://github.com/downloads/cloudera/hue/hue-1.2.0.tgz">Download release tarball</a></li>
+      <li><a href="docs-1.2.0/index.html">Documentation</a></li>
+    </ul>
+
+   <h2>Hue 1.1.0</h2>
     <p>Hue 1.1.0 supports Kerberos integration with using a secured Hadoop
-    cluster. It works with <a href="https://docs.cloudera.com/display/DOC/Hadoop+(CDH3)+Quick+Start+Guide">Cloudera's Distribution for Hadoop (CDH) version 3 beta 3</a></p>
+    cluster. It works with <a href="https://docs.cloudera.com/display/DOC/CDH3+Quick+Start+Guide">Cloudera's Distribution for Apache Hadoop (CDH) version 3 beta 3</a>.</p>
     <ul>
       <li><a href="http://github.com/downloads/cloudera/hue/hue-1.1.0.tgz">Download release tarball</a></li>
       <li><a href="docs-1.1.0/index.html">Documentation</a></li>
@@ -63,8 +70,8 @@
 
     <h2>Contact</h2>
     <ul>
-      <li><a href="mailto:hue-users@cloudera.org">Hue users</a> (<a href="http://groups.google.com/a/cloudera.org/group/hue-user">subscribe</a>)</li>
-      <li><a href="mailto:hue-users@cloudera.org">Hue developers</a> (<a href="http://groups.google.com/a/cloudera.org/group/hue-dev">subscribe</a>)</li>
+      <li><a href="mailto:hue-user@cloudera.org">Hue users</a> (<a href="http://groups.google.com/a/cloudera.org/group/hue-user">subscribe</a>)</li>
+      <li><a href="mailto:hue-dev@cloudera.org">Hue developers</a> (<a href="http://groups.google.com/a/cloudera.org/group/hue-dev">subscribe</a>)</li>
     </ul>
 
     <h2>License</h2>